//-------------------------------------------------------------------------------------------------------------------------------
{FN Form Active/Inactive}
procedure form_FNInh(Active: Boolean);
begin
  FnForm_btn_New           .Enabled :=  Active;
  FnForm_btn_Modify        .Enabled :=  Active and (FNForm_lb_FN.SelCount>0);
  FnForm_btn_Delete        .Enabled :=  Active and (FNForm_lb_FN.SelCount>0);
  FnForm_btn_Refresh       .Enabled :=  Active;
  FnForm_btn_Upload        .Enabled :=  Active and not ADSForm_rb_Offline.Checked;
  FnForm_btn_Download      .Enabled :=  Active and not ADSForm_rb_Offline.Checked;
  FnForm_btn_Preview       .Enabled :=  Active;
  FnForm_btn_Save          .Enabled :=  Active;
  FnForm_btn_Close         .Enabled :=  Active;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Make Time from FN record}
function MakeFnTime(FN: TSqliteTable): TDateTime;
var
  str : String;
begin
  str    := RegexExtract('\d{4}$', '0000' + FN.FieldAsString(FN.FieldIndex['gs_finderid']));    // doplni na format hhmm a orizne
  Result := EncodeTime(StrToInt(copy(str,1,2)),StrToInt(copy(str,3,2)),0,0);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Make DateTime from FN record}
function MakeFnDT(FN: TSqliteTable): TDateTime;
begin
  Result := IntToDate(FN.FieldAsString(FN.FieldIndex['dt'])) + MakeFnTime(FN);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Get FN ID from string}
function GetFnID(str: String): String;
begin
  Result := RegexExtract('GC\w+', str);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Read FN up}
procedure form_FnRead(Sender: TObject);
var  
  FN_db  : TSqliteDatabase; // databaze s tabulkou logu 
  FN     : TSqliteTable;    // tabulka logu
  str    : String;
begin
  form_FnInh(False);
  Fn_db := TSqliteDatabase.Create(MakroPath + 'Data\_adrake.db3');
  try
    with FnForm_lb_FN do begin
      Sorted := False;
      Items.Clear;
      if SQLTableExists(FN_db, 'geolog') then begin
        case TBitBtn(Sender).Name of       // nacte tabulku logu dle zvoleneho razeni
          'btn_ArrDate_Dwn': FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY dt   ASC,  gs_finderid ASC' , false);
          'btn_ArrDate_Up' : FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY dt   DESC, gs_finderid DESC', false);
          'btn_ArrID_Dwn'  : FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY id   ASC'                   , false);
          'btn_ArrID_Up'   : FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY id   DESC'                  , false);
          'btn_ArrType_Dwn': FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY type ASC'                   , false);
          'btn_ArrType_Up' : FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY type DESC'                  , false);
          else               FN := FN_db.GetTable('SELECT * FROM geolog ORDER BY dt   DESC, gs_finderid DESC', false);
        end;
        try
          while not FN.EOF do begin
            str := UtfToAnsi(GEOGET_DB.GetTableString('SELECT name FROM geocache WHERE id = "' + FN.FieldAsString(FN.FieldIndex['id']) + '"'));  //nazev kese
            if str = '' then str := 'not found in GG database';   //pokud neni nazev, kes neni v databazi
            str := FormatDateTime('dd.mm.yyyy hh:mm',  MakeFnDT(FN)) + TAB + FN.FieldAsString(FN.FieldIndex['id']) + TAB + FixLen(str,25);
            Items.Add( str + TAB + FN.FieldAsString(FN.FieldIndex['type']));
            FN.next;                   // skok na dalsi
          end;
          if str = '' then Items.Add(_('- no logs in table -'));
        except
          ShowErrorMessage(ExceptionToString(ExceptionType, ExceptionParam));
        finally
          FN.free;
        end;
      end
      else Items.Add('- geolog table not found -');
    end;
  except
    ShowErrorMessage(ExceptionToString(ExceptionType, ExceptionParam));
  finally
    FN_db.free;
  end;  
  form_FnInh(True);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - zobrazeni obsahu FN}
procedure form_FnInfo(Sender: TObject);
var
  FN_db  : TSqliteDatabase; // databaze s tabulkou logu 
  FN     : TSqliteTable;    // tabulka logu
  id     : String;
begin
  form_FNInh(False);
  with FNForm_lb_FN do begin
    FN_db := TSqliteDatabase.Create(MakroPath + 'Data\_adrake.db3');
    try
      id := GetFnID(Items[ItemIndex]);
      if (id <> '') and SQLTableExists(FN_db, 'geolog') then begin
        FN := FN_db.GetTable('SELECT * FROM geolog WHERE id="'+id+'"' , false);
        if not FN.EOF then begin
          FnForm_ed_Log_ID  .Text := FN.FieldAsString(FN.FieldIndex['id']);
          FnForm_ed_Log_Name.Text := UtfToAnsi(GEOGET_DB.GetTableString('SELECT name FROM geocache WHERE id = "'+id+'"'));
          FnForm_ed_Log_Type.Text := FN.FieldAsString(FN.FieldIndex['type']);
          FnForm_ed_Log_Text.Text := zDecompress(FN.FieldAsBlobText(FN.FieldIndex['logtext']));
          FnForm_dt_Log_Date.Date := IntToDate(FN.FieldAsString(FN.FieldIndex['dt']));
          FnForm_dt_Log_Time.Time := MakeFnTime(FN);
        end;
        FN.free;
      end; 
    finally
      FN_db.free;
    end;
  end;
  form_FNInh(True);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Add a new FN}
procedure form_FnNew(Sender: TObject);
var
  FN_db    : TSqliteDatabase; // databaze s tabulkou logu 
begin
  FN_db := TSqliteDatabase.Create(MakroPath + 'Data\_adrake.db3');
  try
    if (Trim(FnForm_ed_Log_ID.Text) <> '') and SQLTableExists(FN_db, 'geolog') then begin
      FN_db.ExecSQL('INSERT INTO geolog (id,dt,type,finder,logtext,gs_logid,gs_finderid,hash,dtupdate2) VALUES(' + '"' + Trim(FnForm_ed_Log_ID.Text)                     + '"' + ',' 
                                                                                                                 + '"' + DateToInt(FnForm_dt_Log_Date.Date)              + '"' + ','
                                                                                                                 + '"' + FnForm_ed_Log_Type.Text                         + '"' + ','   
                                                                                                                 + '"' + AnsiToUtf('ubi')                               + '"' + ','   
                                                                                                                 + '"' + AnsiToUtf(FnForm_ed_Log_Text.Text)              + '"' + ','
                                                                                                                 + '"' + '-1'                                            + '"' + ','
                                                                                                                 + '"' + FormatDateTime('hhmm', FnForm_dt_Log_Time.Time) + '"' + ','      
                                                                                                                 + '"' + '0'                                             + '"' + ','   
                                                                                                                 + '"' + FloatToStr(now)                                 + '"' + ')'); 
    end;                                                                                                                 
  finally
    FN_db.free;
  end;
  form_FnRead(FnForm_btn_Refresh);    //nacte aktualizovany seznam logu
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Delete FN}
procedure form_FnDelete(Sender: TObject);
var
  FN_db  : TSqliteDatabase; // databaze s tabulkou logu 
  id     : String;
  i      : Integer;
begin
  with FNForm_lb_FN do begin
    if (SelCount > 0) then begin     // pokud je vybrana nejaka stopa
      form_FNInh(False);
      FN_db := TSqliteDatabase.Create(MakroPath + 'Data\_adrake.db3');
      try
        for i := (Items.Count - 1) downto 0 do begin 
          GB_Progress(1,(Items.Count-i),Items.Count);
          if Selected[i] then begin
            id := GetFNID(Items[i]);
            if id <> '' then begin
              FN_db.ExecSQL('DELETE FROM geolog WHERE id = "' + id + '"');
              Items.Delete(i);
            end; 
          end;
        end;
        FN_db.ExecSQL('Vacuum');
      finally
        FN_db.free;
      end;
      GB_Clean;
      form_FNInh(True);
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - nacteni databze _adrake.db3 z AD}
procedure form_db_FN_Dwn(Sender: TObject);
begin
  GB_Progress(1,10,100);
  form_FnInh(False);
  db_AD_Dwn;                                      // nacte databazi _adrake.db3 z PDA
  form_FnRead(FnForm_btn_Refresh);                // nacte aktualizovany seznam logu
  GB_Progress(1,100,100);
  form_FnInh(True);
  GB_Clean;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - upload databze _adrake.db3 do AD}
procedure form_db_FN_Upl(Sender: TObject);
begin
  GB_Progress(1,10,100);
  form_FnInh(False);
  db_AD_Upl;                                      // zapise databazi _adrake.db3 do PDA
  GB_Progress(1,100,100);
  form_FnInh(True);
  GB_Clean;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Zobrazi okno FN}
procedure form_ShowFnForm(Sender: TObject);
begin
  form_FnRead(FnForm_btn_Refresh);             //nacte aktualizovany seznam logu
  form_FnInh(True);
  GB_Caption(_('FN manager showed'));
  FnForm.ShowModal;
end;
