{########################################################################################################################################################}
// Zobrazeni vysledku
procedure ShowResult(Show: Boolean);
begin
  LogWork(_('Result showed'));
  //Updated
  EndForm_gb_Updated     .Enabled := NumOfUpdated > 0;
  EndForm_tp_NumOfUpdated.Caption := IntToStr(NumOfUpdated);
  EndForm_tp_NumOfUpdated.Enabled := EndForm_gb_Updated.Enabled;
  EndForm_cb_ShowList_Upd.Enabled := EndForm_gb_Updated.Enabled;
  if EndForm_gb_Updated.Enabled then begin 
    EndForm_gb_Updated.Font.Color      := clWindowText;
    EndForm_tp_NumOfUpdated.Font.Color := clWindowText;
  end
  else begin 
    EndForm_gb_Updated.Font.Color      := clSilver;
    EndForm_tp_NumOfUpdated.Font.Color := clSilver;
  end;
  //Imported
  EndForm_gb_Imported     .Enabled := NumOfImported > 0;
  EndForm_tp_NumOfImported.Caption := IntToStr(NumOfImported);
  EndForm_tp_NumOfImported.Enabled := EndForm_gb_Imported.Enabled;
  EndForm_cb_ShowList_Imp .Enabled := EndForm_gb_Imported.Enabled;
  if EndForm_gb_Imported.Enabled then begin 
    EndForm_gb_Imported.Font.Color      := clWindowText;
    EndForm_tp_NumOfImported.Font.Color := clWindowText;
  end
  else begin 
    EndForm_gb_Imported.Font.Color      := clSilver;
    EndForm_tp_NumOfImported.Font.Color := clSilver;
  end;
  // EndForm - FN
  EndForm_gb_FN         .Enabled := NumOfFN > 0;
  EndForm_tp_NumOfFN    .Caption := IntToStr(NumOfFN);
  EndForm_tp_NumOfFN    .Enabled := EndForm_gb_FN.Enabled;
  EndForm_cb_ShowList_FN.Enabled := EndForm_gb_FN.Enabled;
  if EndForm_gb_FN.Enabled      then begin 
    EndForm_gb_FN.Font.Color            := clWindowText;
    EndForm_tp_NumOfFN.Font.Color       := clWindowText;
  end
  else begin 
    EndForm_gb_FN.Font.Color            := clSilver;
    EndForm_tp_NumOfFN.Font.Color       := clSilver;
  end;
  // EndForm - Filtr
  EndForm_cb_ShowList_ggfName.Enabled   := EndForm_cb_ShowList_ggf      .Checked;

  if Show then begin 
    if EndForm.ShowModal = 1 then begin
      SaveIniEndForm('DEFAULT');   // Ulozi parametry z formulare aDrakeSyn_End.gfm
    end;
  end;
end;

{########################################################################################################################################################}
{## PDA -> PC ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PDA_PC(Sender: TObject);
var 
  script : string;
  id     : TStringList;
  m      : integer;
begin
  ADSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PDA to PC sync'));
  SaveProfile('DEFAULT');
  if IsAdOnCard then begin                     //pokud je spravne nastaven disk s AD
    ReadADini(True, not ADSForm_rb_Offline.Checked); // Nacteni nastaveni aDrake z ini
    IsADRunning; // testuje zda neni v PDA spusten aDrake
    // Priprava databaze aDrake
    if ADSForm_rb_db_AD_Custom.Checked then begin
      AD_dbName := ADSForm_cmb_db_AD_CustomName.Text + '.db3';
      AD_dbFile := AD_dbPath + '\' + AD_dbName;
      LogWork(_('- Custom aDrake database: ') + AD_dbFile);
    end;

    // Prenos pracovni databaze _adrake.db3 z PDA do PC (aDrake -> GeoGet)
    if UpdGGForm_cb_Upd_db_Work.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('_adrake.db3 database from PDA is loaded'));      
      CopyPDAtoPC(AD_DataPath+'\_adrake.db3', MakroPath+'Data\_adrake.db3');
    end;
    
    // Prenos FieldNotes z PDA do PC (aDrake -> GeoGet) - prenese obsah cele slozky
    if UpdGGForm_cb_Upd_FieldNotes.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer FieldNotes from aDrake'));
      if AD_FNFile <> '' then begin
        GB_Kind(_('FieldNotes from PDA to PC are copied...'));
        MakeDirPC(SmartPath(PC_FNPath));
        CopyPDAtoPC(AD_FNFile, SmartPath(PC_FNPath)+'\FieldNotes_AD.txt');
        if UpdGGForm_cb_Del_FieldNotes.Checked and ADSForm_rb_CardReader.Checked then DeleteFile(ToCardPath(AD_FNFile));
      end
      else begin
        ShowMessage(_('Location of FieldNotes failed!')+CRLF+
                    _('Check settings of aDrake (Export FieldNotes/File for export).')+CRLF+
                    _('FieldNotes not transferred!'));
        LogWork(_('# Error: FieldNotes from PDA to PC not transferred!'));
      end;
     GB_Clean;
    end;

    // Prenos Tracks z PDA do PC (aDrake -> GeoGet) - prenese obsah cele slozky
    if UpdGGForm_cb_Upd_Tracks.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer Tracks from PDA'));
      if AD_TrackPath <> '' then begin
        GB_Kind(_('Tracks from PDA to PC are copied...'));
        MakeDirPC(SmartPath(PC_TrackPath));
        if ADSForm_rb_CardReader.Checked then begin    //CardReader
          CopyTree(ToCardPath(AD_TrackPath), SmartPath(PC_TrackPath));
          LogWork(    _('= Tracks from PDA to PC transferred'));
          if UpdGGForm_cb_Del_Tracks.Checked then DeleteFiles(ToCardPath(AD_TrackPath) + '\*.*');
        end;
        if ADSForm_rb_FTP       .Checked then begin    //FTP
        end;
      end
      else begin
        ShowMessage(_('Location of Tracks failed!')+CRLF+
                    _('Check settings of aDrake (Export Track/Folder for export).')+CRLF+
                    _('Tracks not transferred!'));
        LogWork(_('# Error: Tracks from PDA to PC not transferred!'));
      end;
    GB_Clean;
    end;

    // Aktualizace databaze z PDA do PC (aDrake -> GeoGet)
    if ADSForm_cb_Upd_db_GG.Checked and not ADSForm_rb_Offline.Checked then begin
      LogWork(_('* Update GeoGet database from aDrake database'));
      if (('AD_' + AD_dbName) <> (ADSForm_lbl_db_GG_Name.Caption + '.db3')) then begin
        GB_Caption(_('Database from aDrake is loaded'));
        GB_Kind(_('copying: ') + AD_dbName + '...');
        if CopyPDAtoPC(AD_dbFile, GEOGET_DATADIR + '\AD_' + AD_dbName) then begin
          LogWork(_('- main database from PDA to PC transfered'));
          SaveIniFloatValue('DEFAULT', 'db_LastDownload', now);                                
          GeoDBSelect('AD_' + ReplaceString(AD_dbName, '.db3', ''));
          // vyfiltrovani kesi, u kterych doslo ke zmene od zadaneho datumu
          try
            id:=TStringList.Create;
            GEOGET_DB.GetTableStrings('SELECT id FROM geocache WHERE dtupdate2 >= ' + FlToStr(ADSForm_dt_db_LastUpdate_Date.Date + ADSForm_dt_db_LastUpdate_Time.Time), id);
            script := ''; NumOfUpdated := 0;
            for m:=0 to (id.count-1) do begin
              script := script + id[m] + CRLF;
              NumOfUpdated := NumOfUpdated + 1;
            end;
            StringToFile(script, MakroPath + 'Data\GeoList_Upd.ggt');
          finally
            id.free;
            LogWork(_('- updated geocaches selected'));
          end;
          // priprava seznamu pro export
          GeoListClear;
          GeoListFileAdd(MakroPath + 'Data\GeoList_Upd.ggt');
          // export zmen do gpx souboru
          GB_Kind(_('changes are exporting...'));
          GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\Geo_Upd.gpx');
          LogWork(_('- updated geocaches exported to "Data\Geo_Upd.gpx"'));
          GeoDBSelect(ADSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
          if not UpdGGForm_cb_Save_db_AD.Checked then DeleteFiles(GEOGET_DATADIR + '\AD_' + ReplaceString(AD_dbName, '.db3', '*'));
          // import zmen z gpx souboru do aktivni databaze
          GB_Kind(_('changes are imported to database ') + ADSForm_lbl_db_GG_Name.Caption);
          GeoImportFile(MakroPath + 'Data\Geo_Upd.gpx');
          LogWork(_('= GeoGet database updated from aDrake database'));
        end;
        GB_Clean;
      end
      else ShowErrorMessage(_('Database transfer "') + ADSForm_lbl_db_GG_Name.Caption + _('" does not have to done!')+CRLF+
                            _('Database name from aDrake is the same as current GeoGet database.')+CRLF+
                            _('Select other GeoGet database!'));
    end;

    if Sender <> ADSForm_btn_All then ShowResult(True);
  end;
  ADSForm.Show;
end;


{########################################################################################################################################################}
{## PC -> Web ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PC_Web(Sender: TObject);
var 
  script         : string;
  path           : string;
  template       : string;
  tmp            : string;
  err            : string;
  Ini_gjFN       : TIniFile;    // INI soubor FieldNotes pro GeoJarry
  m,n            : integer;
  // FN z databaze _adrake.db3
  Log_db         : TSqliteDatabase; // databaze s logy 
  Log_tbl        : TSqliteTable;    // tabulka logu
  Log_num        : Integer;

  idFound        : TStringList;
  FoundNew       : Integer;
  FoundNum       : Integer;
  idOfLog        : string;
  DateOfLog      : string;
  TimeOfLog      : string;
  TypeOfLog      : string;
  TextOfLog      : string;
  dtOfLog        : TDateTime;
  LogIsFoundIt   : boolean;
  FNText         : string;
begin
  ADSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PC to Web sync'));
  SaveProfile('DEFAULT');

    // Generovat FieldNotes z databaze a:Drake
    if ADSForm_cb_Gen_FieldNotes_GG.Checked then begin
      GB_Caption(_('FieldNotes from current GeoGet database are genetated'));
      GB_Kind(_('only records from ') + FormatDateTime('dd"."mm"."yyyy" "hh":"nn', ADSForm_dt_FN_LastUpdate_Date.Date + ADSForm_dt_FN_LastUpdate_Time.Time));
      Log_db := TSqliteDatabase.Create(MakroPath + 'Data\_adrake.db3');
      try
        if SQLTableExists(Log_db, 'geolog') then begin
          Log_tbl := Log_db.GetTable('SELECT id,dt,type,logtext,gs_finderid FROM geolog WHERE ((dt = ' + DateToInt(ADSForm_dt_FN_LastUpdate_Date.Date) + ') AND (gs_finderid > ' + FormatDateTime('hhnn', ADSForm_dt_FN_LastUpdate_Time.Time) + '))'
                                                                                   +     ' OR ( dt > ' + DateToInt(ADSForm_dt_FN_LastUpdate_Date.Date) + ')'
                                                                                   +  ' ORDER BY dt, gs_finderid', false);
          Log_num := Log_db.GetTableValue('SELECT count(*)                  FROM geolog WHERE ((dt = ' + DateToInt(ADSForm_dt_FN_LastUpdate_Date.Date) + ') AND (gs_finderid > ' + FormatDateTime('hhnn', ADSForm_dt_FN_LastUpdate_Time.Time) + '))'
                                                                                   +     ' OR ( dt > ' + DateToInt(ADSForm_dt_FN_LastUpdate_Date.Date) + ')');
          LogWork(_('- logs with timestamp >= ') + FormatDateTime('dd"."mm"."yyyy" "hh":"nn', ADSForm_dt_FN_LastUpdate_Date.Date + ADSForm_dt_FN_LastUpdate_Time.Time) + _(' selected'));
          idFound:=TStringList.Create;
          Geoget_DB.GetTableStrings('SELECT id FROM geocache WHERE dtfound<>0 ORDER BY dtfound, dtfoundtime', idFound);  // naplni tabulku vsech owner nalezu
          LogWork(_('- owner`s all FoundIt logs = ') + IntToStr(idFound.Count));
          GB_Caption(_('FieldNotes from a:Drake database are genetated'));
          GB_Kind(_('only records from ') + FormatDateTime('dd"."mm"."yyyy" "hh":"nn', ADSForm_dt_FN_LastUpdate_Date.Date + ADSForm_dt_FN_LastUpdate_Time.Time));
          try
            m := 0; script := ''; FNText := ''; NumOfFN := 0; FoundNew := 0;
            while not Log_tbl.EOF do begin
              if GB_Test then Break;  //preruseno uzivatelem
              GeoBusyProgress(m, Log_num);
              TypeOfLog    := LowerCase(Log_tbl.FieldAsString(Log_tbl.FieldIndex['type']));
              DateOfLog    := Log_tbl.FieldAsString(Log_tbl.FieldIndex['dt']);
              TimeOfLog    := RegexExtract('\d{4}$', '000'+Log_tbl.FieldAsString(Log_tbl.FieldIndex['gs_finderid']));
              dtOfLog      := IntToDate(DateOfLog) + EncodeTime(StrToInt(copy(TimeOfLog,1,2)),StrToInt(copy(TimeOfLog,3,2)),0,0);
              idOfLog      := Log_tbl.FieldAsString(Log_tbl.FieldIndex['id']);
              TextOfLog    := zDecompress(Log_tbl.FieldAsBlobText(Log_tbl.FieldIndex['logtext']));
              LogIsFoundIt := RegexFind('found it', TypeOfLog);
              template := AD_FNTemplate;       // nacte template pro FN z registru PDA (z nastaveni aDrake)
              template := ReplaceString(template,'[T]', formatdatetime('hh":"nn', dtOfLog));
              if LogIsFoundIt then begin
                FoundNum := -1;
                for n:=0 to (idFound.count-1) do if idFound[n] = idOfLog then FoundNum := n+1;
                if FoundNum = -1 then begin
                  FoundNew := FoundNew + 1;
                  FoundNum := idFound.count + FoundNew;
                end; 
                Template := ReplaceString(template,'[N]', IntToStr(FoundNum));
              end
              else template := RegexReplace('(\[N\]|#\[N\])', template, '', False);
              template := ReplaceString(template,'[L]', TextOfLog);
              template := ReplaceString(template,'\x0d\x0a', CRLF);      // nahrazeni odradkovani (hlavne z FN tepmplate v ini)
              script := script + idOfLog + CRLF;
              FNText := FNText + idOfLog + ','+formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn"Z"', LocalToUTC(dtOfLog))+','+TypeOfLog+',"'+template+'"'+CRLF;
              NumOfFN := NumOfFN + 1;
              Log_tbl.next; m := m+1;      // skok na dalsi
            end;
            MakeDirPC(SmartPath(PC_FNPath));
            StringToFile(FNText, SmartPath(PC_FNPath) +'\FieldNotes_GG.txt');               // Ulozi FieldNotes soubor
            StringToFile(script, Makropath          + 'Data\GeoList_FN.ggt');               // Ulozi seznam kesi jako list.ggt pro pripadne pozdejsi nacteni
          except
            ShowErrorMessage(ExceptionToString(ExceptionType, ExceptionParam));
          finally
            Log_tbl.free;
          end;
        end;
      except
        ShowErrorMessage(ExceptionToString(ExceptionType, ExceptionParam));
      finally
        idFound.free;
        Log_db.free;
      end;  
      SaveIniFloatValue('DEFAULT', 'FN_LastUpdate', Now);                                
      LogWork(_('= FieldNotes from GeoGet database genetated = ') + IntToStr(NumOfFN));
      GB_Clean;
    end;

    // Upload FieldNotes na GC.com
    if ADSForm_cb_Upl_FieldNotes.Checked then begin
      GB_Caption(_('Upload FieldNotes on geocaching.com'));
      GB_Kind(_('looking for GeoJarry...'));
      err := '';
      {pohledame kde je geojarry.exe nebo geojarryw.exe a ulozime do GeojarryExe}
      tmp := SearchFile(GEOGET_DATADIR,'geojarryw.exe');
      if ((tmp <> _('File not found!')) and (FileExists(tmp))) then GeojarryExe := tmp
      else begin
        tmp := SearchFile(GEOGET_DATADIR,'geojarry.exe');
        if ((tmp <> _('File not found!')) and (FileExists(tmp))) then GeojarryExe := tmp;
      end;
      if GeojarryExe <> '' then begin
        LogWork(_('- GeoJarry found: ') + GeojarryExe);
        tmp := SearchFile(GEOGET_DATADIR,'groundspeak.config.pas');
        if ((tmp <> _('File not found!')) and (FileExists(tmp))) then begin
          LogWork(_('- GeoJarry config found: ') + tmp);
          GeojarryConfig := tmp;
          gjUsername := GetVariableValue(GeojarryConfig, 'gsUsername');
          gjPassword := GetVariableValue(GeojarryConfig, 'gsPassword');
          if (GjUsername <> '') and (GjPassword <> '') then begin
            // Provede vlastni upload
            GB_Kind(_('FieldNotes on geocaching.com are uploaded...'));
            MakeGeojarryIni('');
            Ini_gjFN := TIniFile.Create(MakroPath + 'FieldNotes_Upload.ini');
            if ADSForm_rb_Upl_FieldNotes_GG.Checked then path := SmartPath(PC_FNPath) + '\FieldNotes_GG.txt'
                                                    else path := SmartPath(PC_FNPath) + '\FieldNotes_AD.txt';
            if FileExists(path) then begin
              Ini_gjFN.WriteString('form', 'ctl00$ContentBody$FieldNoteLoader', path);
              UploadOnGC;
            end
            else err := _('Error: File of FieldNotes not exists!')+CRLF+ path;
          end
          else err := _('Error: Check login items in groundspeak plugin manager settings!');
        end
        else err := _('Error: GeoJarry is installed incorrectly!')+CRLF+_('Not found "groundspeak.config.pas"');
      end
      else err := _('Error: "geojarry.exe" or "geojarryw.exe" not found!');
      if err = '' then LogWork(_('= FieldNotes on geocaching.com uploaded'))
                  else begin
                    ShowMessage(script);
                    LogWork('# ' + ReplaceString(err,CRLF,' '));
                    LogWork(_('# Error: FieldNotes on geocaching.com not uploaded!'));
                  end;
      MakeGeojarryIni('destroy');                           // odstrani heslo na gc.com z gjtemp.ini
      DeleteFiles(MakroPath + 'Data\*.setform.htm');        // odstrani html soubory po GeoJarrym
      GB_Clean;
    end;

    if Sender <> ADSForm_btn_All then ShowResult(True);
    ADSForm.Show;
end;

{########################################################################################################################################################}
{## PC -> PDA ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PC_PDA(Sender: TObject);
var 
  script   : string;
  str      : string;
  x,y      : string;
  key      : string;
begin
  ADSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PC to PDA sync'));
  SaveProfile('DEFAULT');
  if IsAdOnCard then begin  // pokud je spravne nastaven disk s AD
    ReadADini(True, not ADSForm_rb_Offline.Checked); // Nacteni nastaveni aDrake z ini
    IsADRunning; // testuje zda neni v PDA spusten aDrake
    // Priprava databaze aDrake
    if ADSForm_rb_db_AD_Custom.Checked then begin
      AD_dbName := ADSForm_cmb_db_AD_CustomName.Text + '.db3';
      AD_dbFile := AD_dbPath + '\' + AD_dbName;
      LogWork(_('- Custom aDrake database: ') + AD_dbFile);
    end;
    // Prenos databaze z PC do PDA (GeoGet -> aDrake)
    if ADSForm_cb_Upd_db_AD.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer database to PDA'));
      if (LoadIniFloatValue('DEFAULT', 'db_LastDownload', 0.0) + (1.0/24)) < now then begin
        ShowErrorMessage(_('Last downloaded database from a:Drake is older than 1h! ')+CRLF+
                         _('Last download: ')+FormatDateTime('dd.mm.yyyy hh:mm:ss', LoadIniFloatValue('DEFAULT', 'db_LastDownload', 0.0))+CRLF+CRLF+
                         _('Overwriting of the database will delete last changes!'));
      end;
      
      // vytvori pracovni databazi "$aDrake_Work$.db3" pro prenos do PDA
      dbWorkListCreate;  

      // Prepare reference points to AD database
      if UpdADForm_cb_AD_Ref_points.Checked then begin
        GB_Kind(_('Reference points are preparing'));
        if FileExists(GEOGET_DATADIR + '/geohome.ini') then begin
          try
            GeoDBSelect('$aDrake_Work$');                // prepne na pracovni databazi
            SQLVersionTest(GEOGET_DB, '$aDrake_Work$');  // zkontroluje verzi databaze
            key := GEOGET_DB.GetTableString('SELECT key FROM geocache WHERE id="GC0"');
            if (key = '') then GEOGET_DB.ExecSQL('INSERT INTO geocache (id,guid,x,y,name,author,cachetype,cachesize,difficulty,terrain,dtupdate,dtupdate2,country,state,gs_cacheid,gs_ownerid) VALUES ("GC0","","0.0","0.0","aDrake","aDrake","Unknown Cache","Not chosen","0.1","0.1","'+DateToInt(date)+'","'+FloatToStr(now)+'","","","","")');
            script := AnsiToUtf(FileToString(GEOGET_DATADIR + '/geohome.ini'));
            while script <> '' do begin
              str := Fetch(script, CRLF);
              x := Trim(RegexExtract('^\S+' , str));
              y := Trim(RegexExtract(' \S+ ', str));
              str :=      ReplaceString(str, x, '');
              str := Trim(ReplaceString(str, y, ''));
              key := GEOGET_DB.GetTableString('SELECT key FROM waypoint WHERE id="GC0" AND name="' + str + '"');
              if (key = '') then begin
                key := '00';
                repeat
                  key := FormatFloat('00', (StrToFloat(key) + 1));
                until (GEOGET_DB.GetTableString('SELECT prefixid FROM waypoint WHERE id="GC0" AND prefixid="' + key + '"') = '');
                GEOGET_DB.ExecSQL('INSERT  INTO waypoint (id,guid,x,y,name,prefixid,lookup,wpttype,cmt,dtupdate,dtupdate2) VALUES ("GC0","","'+x+'","'+y+'","'+str+'","'+key+'","","Reference Point","","'+DateToInt(date)+'","'+FloatToStr(now)+'")');
              end
              else begin
                GEOGET_DB.ExecSQL('REPLACE INTO waypoint (key,x,y,dtupdate,dtupdate2) VALUES ("'+key+'","'+x+'","'+y+'","'+DateToInt(date)+'","'+FloatToStr(now)+'")');
              end;
            end;
          finally
            LogWork(_('- Reference Points prepared.'));
            GeoDBSelect(ADSForm_lbl_db_GG_Name.Caption);  // prepne na aktivni databazi
          end;
        end;
      end;   

      // odeslani hlavni databaze do PDA
      if ADSForm_rb_db_GG_Filter.Checked then GB_Kind(_('list is copied from database: "') + ADSForm_lbl_db_GG_Name.Caption + '"')
                                         else GB_Kind(_('copying of database: "')          + ADSForm_lbl_db_GG_Name.Caption + '"');
      if CopyPCtoPDA(GEOGET_DATADIR+'\$aDrake_Work$.db3', AD_dbFile) then SaveIniFloatValue('DEFAULT', 'db_LastUpload', now);
      DeleteFiles(GEOGET_DATADIR+'\$aDrake_Work$*');   // odstrani pracovni databaze
      GB_Clean;
    end;

    // Synchronizace offline listingu)
    if ADSForm_cb_Sync_Img.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('Offline listings are synchronized'));
      // vlastni synchronizace
      if ADSForm_rb_CardReader.Checked then begin
        RunSync(GEOGET_DATADIR + '\offline\cache'    , ToCardPath(AD_dbPath) + '\offline\Cache'    , '(1/6) ' +_('synchronizing listings, please wait...'),                    'aDrake_Sync_OfflCache');
        RunSync(GEOGET_DATADIR + '\offline\inc'      , ToCardPath(AD_dbPath) + '\offline\Inc'      , '(2/6) ' +_('synchronizing pictures of listings, please wait...'),        'aDrake_Sync_OfflInc');
        RunSync(GEOGET_DATADIR + '\offline\img'      , ToCardPath(AD_dbPath) + '\offline\Img'      , '(3/6) ' +_('synchronizing shared pictures of listings, please wait...'), 'aDrake_Sync_OfflImg');
        RunSync(GEOGET_DATADIR + '\offline\maps'     , ToCardPath(AD_dbPath) + '\offline\Maps'     , '(4/6) ' +_('synchronizing maps of listings, please wait...'),            'aDrake_Sync_OfflMaps');
        RunSync(GEOGET_DATADIR + '\offline\sysimg'   , ToCardPath(AD_dbPath) + '\offline\SysImg'   , '(5/6) ' +_('synchronizing system pictures of listings, please wait...'), 'aDrake_Sync_OfflSysImg');
        RunSync(GEOGET_DATADIR + '\offline\index'    , ToCardPath(AD_dbPath) + '\offline\Index'    , '(6/6) ' +_('synchronizing index of listings, please wait...'),           'aDrake_Sync_OfflIndex');
        CopyFile(GEOGET_DATADIR + '\offline\index.htm', ToCardPath(AD_dbPath) + '\offline\index.htm');
      end
      else begin
        //FTP
      end;
      LogWork(_('= Offline listings synchronized'));
      GB_Clean;
    end;

    // Synchronizace externich priloh kesi - GEOGET_DATADIR\attach)
    if ADSForm_cb_Sync_Attach.Checked and not ADSForm_rb_Offline.Checked then begin
      GB_Caption(_('Attachments are synchronized'));
      // vlastni synchronizace
      if ADSForm_rb_CardReader.Checked then begin
        RunSync(GEOGET_DATADIR + '\attach', ToCardPath(AD_dbPath) + '\Attach', _('synchronizing attachments, please wait...'), 'aDrake_Sync_Attach');
      end
      else begin
        GB_Kind(_('synchronizing attachments, please wait...'));
        //FTP
      end;
      LogWork(_('= Attachments synchronized'));
      GB_Clean;
    end;

    if Sender <> ADSForm_btn_All then ShowResult(True);
  end;
  ADSForm.Show;
end;


{########################################################################################################################################################}
// Vsechny funkce najednou
procedure form_All(Sender: TObject);
begin
  form_PDA_PC(Sender);
  form_PC_Web(Sender);
  form_PC_PDA(Sender);
  ShowResult(True);
end;
