//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi jeden klic do ini souboru}
procedure SaveIniIntValue(Section: String; Key: String; Value: Integer);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Ini_AD.WriteInteger(Section, Key, Value);
  finally
    Ini_AD.Free;
  end;
end;
procedure SaveIniStrValue(Section: String; Key: String; Value: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Ini_AD.WriteString(Section, Key, Value);
  finally
    Ini_AD.Free;
  end;
end;
procedure SaveIniFloatValue(Section: String; Key: String; Value: Single);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Ini_AD.WriteFloat(Section, Key, Value);
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte jeden klic z ini souboru}
function LoadIniIntValue(Section: String; Key: String; InitValue: Integer): Integer;
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Result := Ini_AD.ReadInteger(Section, Key, InitValue);
  finally
    Ini_AD.Free;
  end;
end;
function LoadIniStrValue(Section: String; Key: String; InitValue: String): String;
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Result := Ini_AD.ReadString(Section, Key, InitValue);
  finally
    Ini_AD.Free;
  end;
end;
function LoadIniFloatValue(Section: String; Key: String; InitValue: Single): Single;
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    Result := Ini_AD.ReadFloat(Section, Key, InitValue);
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi profil}
procedure SaveProfile(Name: String);
var
  Ini_AD  : TIniFile;
  i       : integer;
begin
  if (Name <> 'DEFAULT') and (ADSForm_cmb_Profile.ItemIndex = -1) then
    ADSForm_cmb_Profile.Items.Add(Name);
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      EraseSection('PROFILES');
      for i:= 0 to ADSForm_cmb_Profile.Items.Count - 1 do begin
        WriteInteger('PROFILES', ADSForm_cmb_Profile.Items[i], i);
        if ADSForm_cmb_Profile.Items[i] = Name then ADSForm_cmb_Profile.ItemIndex := i;
      end;
      WriteBool   (Name, 'FTP'                   , ADSForm_rb_FTP                   .Checked  );
      WriteBool   (Name, 'CardReader'            , ADSForm_rb_CardReader            .Checked  );
      WriteBool   (Name, 'MTP'                   , ADSForm_rb_MTP                   .Checked  );
      WriteBool   (Name, 'OffLine'               , ADSForm_rb_Offline               .Checked  );
      WriteBool   (Name, 'db_GG_Full'            , ADSForm_rb_db_GG_Full            .Checked  );
      WriteBool   (Name, 'db_GG_Filter'          , ADSForm_rb_db_GG_Filter          .Checked  );
      WriteBool   (Name, 'db_AD_Default'         , ADSForm_rb_db_AD_Default         .Checked  );
      WriteBool   (Name, 'db_AD_Custom'          , ADSForm_rb_db_AD_Custom          .Checked  );
      WriteString (Name, 'db_AD_CustomName'      , ADSForm_cmb_db_AD_CustomName     .Text     );
      WriteBool   (Name, 'Upd_db_GG'             , ADSForm_cb_Upd_db_GG             .Checked  );
      WriteBool   (Name, 'Gen_FieldNotes_GG'     , ADSForm_cb_Gen_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Upd_db_Work'           , UpdGGForm_cb_Upd_db_Work         .Checked  );
      WriteBool   (Name, 'Upd_FieldNotes'        , UpdGGForm_cb_Upd_FieldNotes      .Checked  );
      WriteBool   (Name, 'Del_FieldNotes'        , UpdGGForm_cb_Del_FieldNotes      .Checked  );
      WriteBool   (Name, 'Upd_Tracks'            , UpdGGForm_cb_Upd_Tracks          .Checked  );
      WriteBool   (Name, 'Del_Tracks'            , UpdGGForm_cb_Del_Tracks          .Checked  );
      WriteBool   (Name, 'Save_db_AD'            , UpdGGForm_cb_Save_db_AD          .Checked  );
      WriteBool   (Name, 'AD_Ref_Points'         , UpdADForm_cb_AD_Ref_points       .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes'        , ADSForm_cb_Upl_FieldNotes        .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_GG'     , ADSForm_rb_Upl_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_AD'     , ADSForm_rb_Upl_FieldNotes_AD     .Checked  );
      WriteBool   (Name, 'Upd_db_AD'             , ADSForm_cb_Upd_db_AD             .Checked  );
      WriteBool   (Name, 'Sync_Img'              , ADSForm_cb_Sync_Img              .Checked  );
      WriteBool   (Name, 'Sync_Attach'           , ADSForm_cb_Sync_Attach           .Checked  );
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl  .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim      .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim.Text) );
      WriteBool   (Name, 'Map_geoKuk_Del'        , MapForm_cb_Geokuk_Del            .Checked  );
      WriteBool   (Name, 'Map_ShowInfo'          , MapForm_cb_ShowInfo              .Checked  );
      WriteString (Name, 'SD_MTP_RootPath'       , SetForm_ed_MTP_RootPath          .Text);
    end;
  finally
    Ini_AD.Free;
    LogWork(_('- profile saved: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna SetForm}
procedure SaveIniSetForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      WriteBool   (Name, 'AutoUpdate',        SetForm_cb_AutoUpdate     .Checked);
      WriteBool   (Name, 'Log_Enbl',          SetForm_cb_Log_Enbl       .Checked);
      WriteBool   (Name, 'ShowResult_Enbl',   SetForm_cb_ShowResult_Enbl.Checked);
      WriteString (Name, 'SD_MTP_RootPath',   SetForm_ed_MTP_RootPath   .Text);
      WriteString (Name, 'FTP_IP',            SetForm_ed_FTP_IP         .Text);
      WriteString (Name, 'FTP_Port',          SetForm_ed_FTP_Port       .Text);
      WriteString (Name, 'FTP_User',          SetForm_ed_FTP_User       .Text);
      WriteString (Name, 'FTP_Pswd',          SetForm_ed_FTP_Pswd       .Text);
    end;
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna TrkForm}
procedure SaveIniTrkForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl        .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl       .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim            .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim   .Text)    );
    end;
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna EndForm}
procedure SaveIniEndForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      WriteBool   (Name, 'ShowList_ggf'          , EndForm_cb_ShowList_ggf          .Checked  );
      WriteString (Name, 'ShowList_ggfName'      , EndForm_cb_ShowList_ggfName      .Text     );
      WriteBool   (Name, 'ShowList_Orig'         , EndForm_cb_ShowList_Orig         .Checked  );
      WriteBool   (Name, 'ShowList_Upd'          , EndForm_cb_ShowList_Upd          .Checked  );
      WriteBool   (Name, 'ShowList_Imp'          , EndForm_cb_ShowList_Imp          .Checked  );
      WriteBool   (Name, 'ShowList_FN'           , EndForm_cb_ShowList_FN           .Checked  );
    end;
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna SetForm}
procedure ReadIniSetForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      SetForm_cb_AutoUpdate            .Checked   := ReadBool   (Name, 'AutoUpdate'             ,False);
      SetForm_cb_Log_Enbl              .Checked   := ReadBool   (Name, 'Log_Enbl'               ,True);
      SetForm_cb_ShowResult_Enbl       .Checked   := ReadBool   (Name, 'ShowResult_Enbl'        ,True);
      SetForm_ed_MTP_RootPath          .Text      := ReadString (Name, 'SD_MTP_RootPath'        ,'Phone');
      SetForm_ed_FTP_IP                .Text      := ReadString (Name, 'FTP_IP'                 ,'192.168.2.26');
      SetForm_ed_FTP_Port              .Text      := ReadString (Name, 'FTP_Port'               ,'1025');
      SetForm_ed_FTP_User              .Text      := ReadString (Name, 'FTP_User'               ,'User');
      SetForm_ed_FTP_Pswd              .Text      := ReadString (Name, 'FTP_Pswd'               ,'Pasword');
    end;
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna TrkForm}
procedure ReadIniTrkForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      TrkDivideForm_cb_TimeToTrimEnbl        .Checked   := ReadBool   (Name, 'TrackTimeToTrimEnbl'    ,False);
      TrkDivideForm_cb_TrackToTrimEnbl       .Checked   := ReadBool   (Name, 'TrackTrackToTrimEnbl'   ,False);
      TrkDivideForm_dt_TimeToTrim            .Time      := ReadFloat  (Name, 'TrackTimeToTrim'        ,0.041667);  // 1h
      TrkDivideForm_ed_DistToTrim            .Text      := IntToStr(ReadInteger(Name, 'TrackTrackToTrim',10));
    end;
  finally
    Ini_AD.Free;
  end;
end;

//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna EndForm}
procedure ReadIniEndForm(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      EndForm_cb_ShowList_ggf          .Checked   := ReadBool   (Name, 'ShowList_ggf'           ,False);
      EndForm_cb_ShowList_ggfName      .Text      := ReadString (Name, 'ShowList_ggfName'       ,'Default');
      EndForm_cb_ShowList_Orig         .Checked   := ReadBool   (Name, 'ShowList_Orig'          ,False);
      EndForm_cb_ShowList_Upd          .Checked   := ReadBool   (Name, 'ShowList_Upd'           ,True);
      EndForm_cb_ShowList_Imp          .Checked   := ReadBool   (Name, 'ShowList_Imp'           ,True);
      EndForm_cb_ShowList_FN           .Checked   := ReadBool   (Name, 'ShowList_FN'            ,True);
    end;
  finally
    Ini_AD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte profil z ini souboru}
procedure ReadProfile(Name: String);
var Ini_AD : TIniFile;
begin
  Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
  try
    with Ini_AD do
    begin
      if ADSForm_cmb_Profile.Items.Count = 0 then begin
        ReadSection('PROFILES', ADSForm_cmb_Profile.Items);
      end;
      ADSForm_rb_FTP                   .Checked   := ReadBool   (Name, 'FTP'                    ,False);
      ADSForm_rb_CardReader            .Checked   := ReadBool   (Name, 'CardReader'             ,True);
      ADSForm_rb_MTP                   .Checked   := ReadBool   (Name, 'MTP'                    ,False);
      ADSForm_rb_Offline               .Checked   := ReadBool   (Name, 'OffLine'                ,False);
      ADSForm_rb_db_GG_Full            .Checked   := ReadBool   (Name, 'db_GG_Full'             ,True);
      ADSForm_rb_db_GG_Filter          .Checked   := ReadBool   (Name, 'db_GG_Filter'           ,False);
      ADSForm_rb_db_AD_Default         .Checked   := ReadBool   (Name, 'db_AD_Default'          ,True);
      ADSForm_rb_db_AD_Custom          .Checked   := ReadBool   (Name, 'db_AD_Custom'           ,False);
      ADSForm_cmb_db_AD_CustomName     .Text      := ReadString (Name, 'ed_AD_CustomName'       ,'cachedb_bak');
      ADSForm_cb_Upd_db_GG             .Checked   := ReadBool   (Name, 'Upd_db_GG'              ,False);
      ADSForm_cb_Gen_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Gen_FieldNotes_GG'      ,False);
      UpdGGForm_cb_Upd_db_Work         .Checked   := ReadBool   (Name, 'Upd_db_Work'            ,True);
      UpdGGForm_cb_Save_db_AD          .Checked   := ReadBool   (Name, 'Save_db_AD'             ,False);
      UpdGGForm_cb_Upd_FieldNotes      .Checked   := ReadBool   (Name, 'Upd_FieldNotes'         ,False);
      UpdGGForm_cb_Del_FieldNotes      .Checked   := ReadBool   (Name, 'Del_FieldNotes'         ,False);
      UpdGGForm_cb_Upd_Tracks          .Checked   := ReadBool   (Name, 'Upd_Tracks'             ,False);
      UpdGGForm_cb_Del_Tracks          .Checked   := ReadBool   (Name, 'Del_Tracks'             ,False);
      UpdADForm_cb_AD_Ref_points       .Checked   := ReadBool   (Name, 'AD_Ref_Points'          ,False);
      ADSForm_cb_Upl_FieldNotes        .Checked   := ReadBool   (Name, 'Upl_FieldNotes'         ,False);
      ADSForm_rb_Upl_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_GG'      ,True);
      ADSForm_rb_Upl_FieldNotes_AD     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_AD'      ,False);
      ADSForm_cb_Upd_db_AD             .Checked   := ReadBool   (Name, 'Upd_db_AD'              ,False);
      ADSForm_cb_Sync_Img              .Checked   := ReadBool   (Name, 'Sync_Img'               ,False);
      ADSForm_cb_Sync_Attach           .Checked   := ReadBool   (Name, 'Sync_Attach'            ,False);
      MapForm_cb_Geokuk_Del            .Checked   := ReadBool   (Name, 'Map_Geokuk_Del'         ,False);
      MapForm_cb_ShowInfo              .Checked   := ReadBool   (Name, 'Map_ShowInfo'           ,False);
      if (Name = 'DEFAULT') or (Name = 'FACTORY') then begin
        CardPath                                  := ReadString (Name, 'CardPath'               ,'');
        AD_CardPath                               := ReadString (Name, 'AD_CardPath'            ,'/mnt/sdcard');
        IniFile                                   := ReadString (Name, 'IniFile'                ,'adrake\data\adrake.ini');
        MobAtlCrPath                              := ReadString (Name, 'LastMobAtlCrPath'       ,'');
        OziMapPath                                := ReadString (Name, 'LastOziMapPath'         ,'');
        ADSForm_dt_db_LastUpdate_Date  .Date      := Trunc(ReadFloat(Name, 'db_LastUpload'      ,Now - 1));
        ADSForm_dt_db_LastUpdate_Time  .Time      :=       ReadFloat(Name, 'db_LastUpload'      ,Now) - ADSForm_dt_db_LastUpdate_Date.Date + 0.0001;
        ADSForm_dt_FN_LastUpdate_Date  .Date      := Trunc(ReadFloat(Name, 'FN_LastUpdate'      ,Now - 1));
        ADSForm_dt_FN_LastUpdate_Time  .Time      :=       ReadFloat(Name, 'FN_LastUpdate'      ,Now) - ADSForm_dt_FN_LastUpdate_Date.Date + 0.0001;
        ReadIniSetForm(Name);
        ReadIniEndForm(Name);
      end;
    end;
  finally
    Ini_AD.Free;
    LogWork(_('- profile loaded: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - Ulozi profil do ini souboru}
procedure form_SaveProfile(Sender: TObject);
begin
  if ADSForm_cmb_Profile.Text = '' then
    ShowMessage(_('Enter a profile name'))
  else begin
    SaveProfile(ADSForm_cmb_Profile.Text);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - nacteni factory settings}
procedure form_ReadFactoryProfile(Sender: TObject);
begin
    ReadProfile('FACTORY');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - obsluha vyberu profilu}
procedure form_ProfileChanged(Sender: TObject);
begin
  if (ADSForm_cmb_Profile.ItemIndex <> -1) and (ADSForm_cmb_Profile.Items.Count > 0) then begin
    ReadProfile(ADSForm_cmb_Profile.Text);
    ADSForm_btn_Del.Enabled := true;
  end
  else
    ADSForm_btn_Del.Enabled := false;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - smaze profil}
procedure form_DelProfile(Sender: TObject);
var
  Ini_AD: TIniFile;
  i : Integer;
begin
  if ADSForm_cmb_Profile.ItemIndex <> -1 then begin
    Ini_AD := TIniFile.Create(MakroPath + 'aDrakeSync.ini');
    try
      Ini_AD.EraseSection(ADSForm_cmb_Profile.Text);
      Ini_AD.EraseSection('PROFILES');
      ADSForm_cmb_Profile.Items.Delete(ADSForm_cmb_Profile.ItemIndex);
      for i:= 0 to ADSForm_cmb_Profile.Items.Count - 1 do
        Ini_AD.WriteInteger('PROFILES', ADSForm_cmb_Profile.Items[i], i);
    finally
      Ini_AD.Free;
    end;
    if ADSForm_cmb_Profile.Items.Count > 0 then begin
      ADSForm_cmb_Profile.ItemIndex := 0;
      ADSForm_cmb_Profile.Text := ADSForm_cmb_Profile.Items[0];
      ReadProfile(ADSForm_cmb_Profile.Text)
    end
    else begin
      ADSForm_cmb_Profile.ItemIndex := -1;
      ADSForm_cmb_Profile.Text := '';
    end;
    if ADSForm_cmb_Profile.Items.Count = 0 then ADSForm_btn_Del.Enabled := false;
  end;
end;
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte String klic z registru PC - HKEY_CURRENT_USER}
function ReadRegString(RegPath: String; RegKey: String): String;
var reg : TRegistry;
begin
  reg := TRegistry.Create;
  try
    // reg.RootKey:='HKEY_CURRENT_USER';
    if reg.OpenKey(RegPath, False) then
      result := reg.ReadString(RegKey);
  finally
    reg.Free;
  end;
end;
