//-------------------------------------------------------------------------------------------------------------------------------
{Nacteni nastaveni z aDrake.ini}
procedure ReadADini(All: Boolean; Online: Boolean);
var
  Ini       : TIniFile;
  FormShowed: Boolean;
  MapXmlFile: String;
begin
  // nacteni nastaveni z aDrake.ini
  FormShowed := ADSForm.Visible and not (TrkForm.Visible or MapForm.Visible);
  if FormShowed then ADSForm.Hide;
  GB_Caption(_('Settings is loading...'));
  if Online then begin
    MapXmlFile := ReplaceString(Lowercase(IniFile),'adrake.ini','map-config.xml')
    CopyPDAtoPC(AD_CardPath+'/'+ReplaceString(IniFile,   '\','/'), MakroPath + 'Data\aDrake.ini');
    CopyPDAtoPC(AD_CardPath+'/'+ReplaceString(MapXmlFile,'\','/'), MakroPath + 'Data\map-config.xml');
  end;
  GB_Kind(_('reading of AD settings from aDrake.ini'));
  if not FileExists(MakroPath + 'Data\aDrake.ini') then begin
    ShowErrorMessage(_('File not found:') + CRLF + MakroPath + 'Data\aDrake.ini' + CRLF + CRLF +
                     _('If you use Off Line mode,')+
                     _('you have to connect device at least once by CardReader mode before.') + CRLF + CRLF +
                     _('If you use ADS for the first time, click on YES button.'));
  end
  else begin
    Ini := TIniFile.Create(MakroPath + 'Data\aDrake.ini');
    AD_dbFile     := LowerCase(Ini.ReadString('Options', 'DbFile', ''));                 //   ('/mnt/sdcard/adrake/db.db3')
    AD_dbName     := RegexExtract('[^/]+\.db3', AD_dbFile);                             //   ('db.db3')
    AD_dbPath     := ReplaceString(AD_dbFile, '/' + AD_dbName, '');                      //   ('/mnt/sdcard/adrake')
    //AD_CardPath   := LowerCase(Ini.ReadString('Options', 'CardFolder', ''));             //   ('/mnt/sdcard')
    AD_DataPath   := LowerCase(Ini.ReadString('Options', 'DataFolder', ''));             //   ('/mnt/sdcard/adrake/data')
    AD_IniFile    := AD_DataPath + '/adrake.ini';                                        //   ('/mnt/sdcard/adrake/data/adrake.ini')
    AD_isRunning  := LowerCase(Ini.ReadString('Status', 'Running', 'No'));
    IniFile := ReplaceString(AD_IniFile, AD_CardPath+'/', '');
    IniFile := ReplaceString(IniFile, '/', '\');
    if All then begin
      AD_FNFile     := LowerCase(Ini.ReadString('Options', 'FNFile', ''));               //   ('/mnt/sdcard/adrake/fieldnotes/fieldnotes.txt')
      AD_FNName     := RegexExtract('[^/]+\S$', AD_FNFile);                             //   ('fieldnotes.txt')
      AD_FNPath     := ReplaceString(AD_FNFile, '/' + AD_FNName, '');                    //   ('/mnt/sdcard/adrake/fieldnotes')
      AD_FNTemplate := Ini.ReadString('Options', 'FNTemplate', '[T] #[N]\x0d\x0a[L]');
      AD_TrackPath  := LowerCase(Ini.ReadString('Options', 'TrackFolder', ''));          //   ('/mnt/sdcard/adrake/tracks/)
      AD_TrackPath  := RegexReplace('/$', AD_TrackPath,'',False);                       //   ('/mnt/sdcard/adrake/tracks)
      AD_MapPath    := LowerCase(Ini.ReadString('Options', 'MapFolder', ''));            //   ('/mnt/sdcard/adrake/maps/)
      AD_MapPath    := RegexReplace('/$', AD_MapPath,'',False);                         //   ('/mnt/sdcard/adrake/maps)
      AD_Ver        := Ini.ReadString('CurrentVersion', 'Version', '?.?.?.?');
      AD_Lang       := Ini.ReadString('Options', 'Language', 'en');
    end;
    // testuje zda se podarilo nacist vsechna nutna nastaveni z ini souboru
    if AD_dbFile = '' then begin
      ShowErrorMessage(_('Location of aDrake database failed!')+CRLF+
                       _('Check settings of aDrake (Settings/General/Database file).')+CRLF+
                       _('Then you have to connect device at least once by SD Card mode.'));
    end
    else begin
      if AD_dbName = '' then begin
        ShowErrorMessage(_('Name recognition of aDrake database failed!')+CRLF+
                         _('Check settings of aDrake (Settings/General/Database file).')+CRLF+
                         _('Then you have to connect device at least once by SD Card mode.'));
      end
      else begin
        if All then begin
          // kontrola verze aDrake
          if CompareVer(AD_Ver_Min, AD_Ver) then begin            // pokud verze AD < AD_Ver_Min
            ShowErrorMessage(_('For proper operation is required aDrake version ') + AD_Ver_Min + _(' or higher') +CRLF+ _('Your version: ') + AD_Ver);
          end;
          // kontrola nastaveni
          if (AD_FNFile     = '') and UpdGGForm_cb_Upd_FieldNotes.Checked then begin
            ShowErrorMessage(_('Location of FieldNotes failed!')+CRLF+
                             _('Check settings of aDrake (Export FieldNotes/File for export).')+CRLF+
                             _('Then you have to connect device at least once by SD Card mode.'));
          end;
          if (AD_FNTemplate = '') and ADSForm_cb_Gen_FieldNotes_GG.Checked then begin
            ShowErrorMessage(_('Reading of FieldNotes template failed!')+CRLF+
                             _('Check settings of aDrake (Export FieldNotes/Log template).')+CRLF+
                             _('Then you have to connect device at least once by SD Card mode.'));
          end;
          if (AD_TrackPath  = '') and UpdGGForm_cb_Upd_Tracks.Checked then begin
            ShowErrorMessage(_('Location of Tracks failed!')+CRLF+
                             _('Check settings of aDrake (Export Track/Folder for export).')+CRLF+
                             _('Then you have to connect device at least once by SD Card mode.'));
          end;
        end;
      end;
    end;
  end;
  LogWork(_('= Settings loading done.'));
  GB_Clean;
  if FormShowed then ADSForm.Show;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Kontrola spusteneho AD v PDA}
function IsADRunning: Boolean;
begin
  Result := False;
  if (AD_isRunning = 'yes') and ADSForm_rb_FTP.Checked then begin     //u SD karty nema smysl, protoze je odpojena od systemu
    ShowErrorMessage(_('a:Drake is probably running in PDA!')+CRLF+
                     _('Terminate it and continue. Otherwise its databases might be damaged!'));
    Result := True;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Kontrola pritomnosti AD na SD karte}
function IsAdOnCard: Boolean;
begin
  LogWork('IsAdOnCard: ' + AD_dbFile);
  Result := True;
  if ADSForm_rb_CardReader.Checked then begin
    if not FileExists(ToCardPath(AD_dbFile)) then begin
      LogWork(_('# Selected aDrake external disc not contains database: ') + ToCardPath(AD_dbFile));
      if (MessBox(_('File not found on selected disc:') + CRLF + ToCardPath(AD_dbFile) + CRLF + CRLF +
                  _('Probably it is not the aDrake data disc.') + CRLF + CRLF + _('Continue plugin execution?'), _('Attention!'), 4) <> 6) then Result := False;
    end;
  end;
  if ADSForm_rb_MTP.Checked then begin
      if not MtpVerify(ToCardPath(AD_dbFile)) then begin
        LogWork(_('# Selected aDrake external disc not contains database: ') + ToCardPath(AD_dbFile));
        if (MessBox(_('File not found on selected disc:') + CRLF + ToCardPath(AD_dbFile) + CRLF + CRLF +
                    _('Probably it is not the aDrake data disc.') + CRLF + CRLF + _('Continue plugin execution?'), _('Attention!'), 4) <> 6) then Result := False;
      end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Podpora pripojeni pres externi disk}
procedure form_CardPath(Sender: TObject);
var
  script : string;
begin
  if ADSForm_rb_CardReader.Checked then begin
    //  script := SelectDir(CardPath, _('Select aDrake database on a mass storage...')+CRLF+_('Example: E:\'));
      OpenDlg(_('Select aDrake.ini on a mass storage'), CardPath + IniFile, 'ofFileMustExist,ofHideReadOnly', 'aDrake Stettings File (aDrake.ini)|aDrake.ini', Script);
      if script <> '' then begin
        CardPath    := RegexExtract('^\w:\\', script);                          //vykousne pouze pismeno disku [j:\]
        IniFile     := LowerCase(Trim(ReplaceString(Script, CardPath, '')));    //zbytek cesty k ini souboru AD, bez pismenka disku
        AD_CardPath := ReplaceString(AD_DataPath + '/adrake.ini', '/' + ReplaceString(IniFile,'\','/'), '');  // pokus o zjisteni cesty k android karte v android zarizeni
      end;
  end;
  if ADSForm_rb_MTP.Checked then begin
        script := MtpSearch('aDrake.ini');
        CardPath := RegexExtract('^.*:\\', script);             //vykousne pouze pismeno disku [j:\]
        script := ReplaceString(script, CardPath, '');         //zbytek cesty k ini souboru AD, bez pismenka disku
        LogWork('form_CardPath : ' + script);
        SetForm_ed_MTP_RootPath.Text :=  SeparateLeft(script,'\');
        LogWork('form_CardPath : ' + SetForm_ed_MTP_RootPath.Text);
        IniFile  := Trim(ReplaceString(script, SetForm_ed_MTP_RootPath.Text + '\' , ''));  //zbytek cesty k ini souboru AD, bez pismenka disku a SD slozky
        AD_CardPath := ReplaceString(AD_DataPath + '/adrake.ini', '/' + ReplaceString(LowerCase(IniFile),'\','/'), '');  // pokus o zjisteni cesty k android karte v android zarizeni
  end;
  if script <> '' then begin
      ADSForm_ed_AD_IniFile.Text  := IniFile;
      ADSForm_ed_AD_disc   .Text  := CardPath;
      MapForm_ed_AD_disc   .Text  := CardPath;
      SaveIniStrValue('DEFAULT', 'CardPath'   , CardPath);
      SaveIniStrValue('DEFAULT', 'IniFile'    , IniFile);
      SaveIniStrValue('DEFAULT', 'AD_CardPath', AD_CardPath);
      LogWork(_('- aDrake external disc selected: ') + CardPath);
      ReadADini(False, True);    //nacte ini soubor z disku a naplni promenne
      IsAdOnCard;                //kontrola nastaveni disku s AD
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{zjisteni cesty k mapovym kachlim programu GeoKuk}
function SmartPath_GK(path: String): String;
begin
  Result := ReadRegString('\Software\JavaSoft\Prefs\geokuk\current\umisteni/Souboru', 'kachle/Cache/Dir');
  StringToFile(result, Makropath + 'Data\reg_GeoKuk.txt'); // pro testovaci ucely
  Result := RegexReplace('/{2,5}', Result, '\', False);                         // nahradi '//|///|...' z retezce registru znakem '\' (co se to tam do toho registru uklada za nesmysly!!??)
  Result := ReplaceString(Result, '/', '');                                     // odmazne zbyla samostatna '/' z retezce, pokud tam jsou (se tam nejak zbytecne nacpaly na divny mista)
  Result := ReplaceString(path, '<auto>', Result);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - zjisteni databazi v PDA}
procedure form_dbSeek(Sender: TObject);
var
  script : string;
  databases : Array of String;
  i : integer;
begin
  if not ADSForm_rb_Offline.Checked then begin
    ReadADini(False, not ADSForm_rb_Offline.Checked);  // nacte si nastaveni z ini
    if IsAdOnCard then begin     // otestuje umisteni AD na externim disku
      if ADSForm_rb_MTP.Checked then begin
         databases := MtpGetDatabases(ToCardPath(AD_dbPath),'.db3');
         ADSForm_cmb_db_AD_CustomName.Items.Clear;
         for i:=0 to high(databases) do begin
          script:= databases[i];
          ADSForm_cmb_db_AD_CustomName.Items.Add(SeparateLeft(script, '.db3'));
         end;
         ADSForm_cmb_db_AD_CustomName.ItemIndex := ADSForm_cmb_db_AD_CustomName.Items.Count - 1;
      end;
      if ADSForm_rb_CardReader.Checked then script := 'dir "' + ToCardPath(AD_dbPath) + '\*.db3" /B';
      if ADSForm_rb_FTP       .Checked then script := 'rem UNSUPORTED';
      if ADSForm_rb_CardReader.Checked or ADSForm_rb_FTP.Checked then begin
        RunProc(script, 'dbList_PDA', True);
        if FileExists(MakroPath + 'Data\dbList_PDA.txt') then begin
        script := LowerCase(FileToString(MakroPath + 'Data\dbList_PDA.txt'));
          if (script = '') OR (pos('WARNING', script) <> 0) then ShowMessage(_('Reading of database list failed.')+CRLF+CRLF+_('Error code:') +CRLF+ script)
          else begin
            script := RegexExtract('[^\s]+\.db3', script);
            ADSForm_cmb_db_AD_CustomName.Items.Clear;
            while trim(script) <> '' do begin
              ADSForm_cmb_db_AD_CustomName.Items.Add(SeparateLeft(FetchBin(script, CRLF), '.db3'));
            end;
            ADSForm_cmb_db_AD_CustomName.ItemIndex := ADSForm_cmb_db_AD_CustomName.Items.Count - 1;
          end;
        end
        else ShowMessage(_('Error: Creating of database list failed.'));
      end;
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Priprava pracovni databaze GeoGetu -  v pripade ze se pracuje pouze s vyfiltrovanym seznamem}
procedure dbWorkListCreate();
begin
  if ADSForm_rb_db_GG_Filter.Checked then begin
    GB_Caption(_('Temporary GeoGet database is prepared'));
    // export zmen do gpx souboru
    GB_Kind(_('the filtered cache list is exported...'));
    StringToFile('GC0', MakroPath + 'Data\GC0.ggt');  //pro doplneni GC0 (Add-hoc WP) do seznamu
    GeoListFileAdd(MakroPath + 'Data\GC0.ggt');
    DeleteFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\GeoGetFilter_db.gpx');
    if not FileExists(MakroPath + 'Data\GeoGetFilter_db.gpx') then begin
      ShowErrorMessage(_('Error: File "') + MakroPath + 'Data\GeoGetFilter_db.gpx' + _('" not found!') + CRLF
                     + _('Check export macro: ') + CRLF + GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas');
    end;
    // vytvori pracovni databazi
    GeoDBSelect('$aDrake_Work$');                    // zalozi pracovni databazi
    GB_Kind(_('the list is imported to a work database...'));
    GeoImportFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoDBSelect(ADSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
    GB_Clean;
  end
  else CopyFile(GEOGET_DATADIR + '\' + GEOGET_DBNAME + '.db3', GEOGET_DATADIR + '\' + '$aDrake_Work$.db3');
  LogWork(_('- Temporary GG database created: $aDrake_Work$'));
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Naplni StringList soubory z daneho adresare vcetne podadresaru}
procedure FileAllList(Dir, RegexMaskPath, RegexMaskFile: string; List: TStringList);
var
  Files,Queue  : TStringList;
  n : Integer;
begin
  if DirectoryExists(Dir) then begin
    Queue    := TStringList.Create;
    Files    := TStringList.Create;
    try
      Queue.Add(Dir);
      while (Queue.Count > 0) do begin
        if GB_Test then Break;  //preruseno uzivatelem
        GB_Progress(1, Trunc(sqrt(List.Count)) ,Trunc(sqrt(List.Count))+1);
        FileList(Queue[0],Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do begin
          if RegexFind('\\$',Files[n]) then begin if RegexFind(RegexMaskPath,Files[n]) then Queue.Add(Files[n]); end
                                       else begin if RegexFind(RegexMaskFile,Files[n]) then List.Add(Files[n]);  end;
        end;
      end;
      GB_Progress(1, 0 ,100);
    finally;
      Queue.Free; Files.Free;
    end;
  end;
end;
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Kopiruje obsah adresare PC<->PC vcetne podslozek, pouze soubory dle zadane regex masky}
procedure SmartCopyPC(FromDir: string; ToDir: string; RegexMaskFile: string; Caption: string);
var
  Files        : TStringList;
  NameDestFile : string;
  n : Integer;
begin
  if not RegexFind('\\$',FromDir) then FromDir := FromDir + '\';
  if not RegexFind('\\$',ToDir)   then ToDir   := ToDir   + '\';
  if DirectoryExists(FromDir) then begin
    GB_Caption(Caption);
    Files    := TStringList.Create;
    try
      GB_Kind(_('files are calculated:') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      GB_Value(FromDir + RegexMaskFile);
      FileAllList(FromDir, '.*', RegexMaskFile, Files);   //naplni seznam vsech souboru z adresare a jeho podadresaru
      GB_Kind(_('files are copied: ') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      for n := 0 to Files.Count-1 do begin
        GB_Progress(1, n ,Files.Count);
        NameDestFile   := ToDir + ReplaceString(Files[n], FromDir, '');
        MakeDirPC(ReplaceString(NameDestFile, RegexExtract('[^\\]+\S$',NameDestFile), ''));
        CopyFile(Files[n], NameDestFile);
        if GB_Test then Break;  //preruseno uzivatelem
      end;
      LogWork(' .. SmartCopyPC: ' + Caption);
    finally
      Files.Free;
    end;
    GB_Clean;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Synchronizuje obsah adresare PC<->PC vcetne podslozek}
procedure RunSync(FromDir: string; ToDir: string; Caption: string; NameOfBatch: string);
var Ini_Toucan : TIniFile;
    cmd        : String;
begin
  if not RegexFind('\\$',FromDir) then FromDir := FromDir + '\';
  if not RegexFind('\\$',ToDir)   then ToDir   := ToDir   + '\';
  GB_Caption(Caption);
  Ini_Toucan := TIniFile.Create(MakroPath + 'Toucan\Data\Jobs.ini');
  try
    with Ini_Toucan do
    begin
      WriteString(NameOfBatch, 'Type',           'Sync');
      WriteString(NameOfBatch, 'Source'  ,       ReplaceString(FromDir,'\','\\'));
      WriteString(NameOfBatch, 'Dest'    ,       ReplaceString(ToDir,'\','\\'));
      WriteString(NameOfBatch, 'Function',       'Equalise');
      WriteBool  (NameOfBatch, 'CheckSize',      False);
      WriteBool  (NameOfBatch, 'CheckTime',      True);
      WriteBool  (NameOfBatch, 'CheckShort',     False);
      WriteBool  (NameOfBatch, 'CheckFull',      False);
      WriteBool  (NameOfBatch, 'TimeStamps',     False);
      WriteBool  (NameOfBatch, 'Attributes',     False);
      WriteBool  (NameOfBatch, 'IgnoreReadOnly', False);
      WriteBool  (NameOfBatch, 'Recycle',        False);
      WriteBool  (NameOfBatch, 'PreviewChanges', False);
      WriteString(NameOfBatch, 'Rules', '');
    end;
  finally
    Ini_Toucan.Free;
    LogWork(_('- Toucan Job created as: ') + NameOfBatch);
  end;
  cmd := '"' + MakroPath + 'Toucan\Toucan.exe" --job=' + NameOfBatch;
  StringToFile(AnsiToOEM(cmd), NameOfBatch + '.bat');
  RunExec(cmd);
  GB_Clean;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{nacte _adrake.db3 z PDA}
procedure db_AD_Dwn;
begin
  GB_Progress(1,20,100);
  ReadADini(True, not ADSForm_rb_Offline.Checked);  // Nacteni nastaveni aDrake z registru PDA
  GB_Progress(1,30,100);
  if IsAdOnCard then begin                          // Kontrola pritomnosti AD na SD karte
    IsADRunning;                                    // testuje zda neni v PDA spusten aDrake
    GB_Progress(1,40,100);
    GB_Caption(_('_adrake.db3 database from PDA is loaded'));
    CopyPDAtoPC(AD_DataPath+'\_adrake.db3', MakroPath+'Data\_adrake.db3');
    GB_Progress(1,90,100);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{zapise _adrake.db3 do PDA}
procedure db_AD_Upl;
begin
  GB_Progress(1,20,100);
  ReadADini(True, not ADSForm_rb_Offline.Checked);  // Nacteni nastaveni aDrake z registru PDA
  GB_Progress(1,30,100);
  if IsAdOnCard then begin                          // Kontrola pritomnosti AD na SD karte
    Vacuum(MakroPath + 'Data\_adrake.db3');
    GB_Progress(1,40,100);
    IsADRunning;                                    // testuje zda neni v PDA spusten aDrake
    GB_Progress(1,50,100);
    GB_Caption(_('Transfer _adrake.db3 database to PDA'));
    CopyPCtoPDA(MakroPath+'Data\_adrake.db3', AD_DataPath+'\_adrake.db3');
    GB_Progress(1,90,100);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
