uses aDrakeSync,       aDrakeSync_End,      aDrakeSync_Set, 
     aDrakeSync_UpdGG, aDrakeSync_UpdAD,    aDrakeSync_ADSet,
     aDrakeSync_Log,   aDrakeSync_FN,
     aDrakeSync_Map,   aDrakeSync_MapMng,   aDrakeSync_Ins,
     aDrakeSync_Trk,   aDrakeSync_TrkDivide;

{$V 2.6.3}                      // Minimalni verze GeoGetu

const
  AD_Ver_Min  = '0.2';          // Minimalni verze aDrake
  SQL_Ver_Min = '2';            // Minimalni verze SQL databaze kesi

var
  MakroPath      : string;      // cesta k adresari Makra (bez posledniho lomitka)
  CardPath       : string;      // plna cesta k disku v PC s kartou z PDA, [J:\]
  IniFile        : string;      // cesta k souboru konfigurace adrake.ini  [adrake\data\adrake.ini] (bez pismenka disku, to je v CardPath)
  MobAtlCrPath   : string;      // plna cesta k adresari atlasu MobileAtlasCreatoru v PC [C:\MobileAtlasCreator\Mobile Atlas Creator 1.8 beta 1\atlases\aDrake_2010-09-04_215323\]
  OziMapPath     : string;      // plna cesta k adresari atlasu kachli z OziExploreru
  GeojarryExe    : string;      // umisteni exe geojarry vcetne plne cesty
  GeojarryConfig : string;      // plna cesta i s nazvem souboru ke konfiguracnimu souboru GeoJarry
  GjUsername     : string;      // klice konfigu gj2.config.pas
  GjPassword     : string;      //
  // Settings from PDA register
  AD_IniFile     : string;      // plna cesta k souboru konfigurace adrake.ini  [/mnt/sdcard/adrake/data/adrake.ini] (bez pismenka disku, to je v CardPath)
  AD_dbFile      : string;      // plna cesta s nazvem souboru databaze         [/mnt/sdcard/adrake/cachedb.db3]
  AD_dbName      : string;      // nazev souboru databaze                       [cachedb.db3]
  AD_dbPath      : string;      // cesta k souboru databaze v PDA               [/mnt/sdcard/adrake]
  AD_CardPath    : string;      // cesta k SD karte (pro nahraz. pri kop do PC) [/mnt/sdcard]
  AD_DataPath    : string;      // cesta k datove slozce                        [/mnt/sdcard/adrake/data]
  AD_FNFile      : string;      // plna cesta s nazvem souboru FieldNotes v PDA
  AD_FNName      : string;      // nazev souboru FieldNotes v PDA vcetne pripony .txt
  AD_FNPath      : string;      // cesta k FieldNotes v PDA (bez posledniho lomitka)
  AD_TrackPath   : string;      // plna cesta k Tracks v PDA (bez posledniho lomitka)
  AD_MapPath     : string;      // plna cesta k Maps v PDA (bez posledniho lomitka)
  AD_FNTemplate  : string;      // sablona FieldNote
  AD_Ver         : string;      // aktualni verze AD v PDA
  AD_Lang        : string;      // nastavena jazykova mutace AD
  AD_isRunning   : string;      // priznak, ze je v PDA spusten a:Drake
  // Results number of main operations
  NumOfUpdated   : Integer;     // pocet aktualizovanych bodu v databazi GG z databaze AD
  NumOfImported  : Integer;     // pocet importovanych bodu z webu pres gpx do AD
  NumOfFN        : Integer;     // pocet generovanych FN z databaze GG
  // Global GeoBusy dialog text
  GB_Caption_Text      : String;
  GB_Kind_Text         : String;
  GB_Value_Text        : String;
  GB_Progress_Value    : Integer;
  GB_Progress_MaxValue : Integer;
  //
  TAB            : Char;        // tabulator
  EventCancel    : Boolean;     // priznak stisku STOP/CANCEL z ostatnich dialogu 
  // Maps Manager
  NumCopyImgDone : Integer;     // pocet opravdu zkopirovanych map
  NumCopyImgAll  : Integer;     // pocet skutecne zkopirovanych map
  // Track Manager
  Trk_List_Arrng : String;      // zpusob razeni seznamu stop
